## fdb 5.14.0

=== src/fdb5/CMakeLists.txt ===
ecbuild_generate_config_headers( DESTINATION ${INSTALL_INCLUDE_DIR}/fdb5 )

configure_file( fdb5_config.h.in    fdb5_config.h   )
configure_file( fdb5_version.h.in   fdb5_version.h  )
configure_file( fdb5_version.c.in   ${CMAKE_CURRENT_BINARY_DIR}/fdb5_version.c   )

install( FILES ${CMAKE_CURRENT_BINARY_DIR}/fdb5_config.h
               ${CMAKE_CURRENT_BINARY_DIR}/fdb5_version.h
         DESTINATION ${INSTALL_INCLUDE_DIR}/fdb5 )

# fdb5 library

list( APPEND fdb5_srcs
    ${CMAKE_CURRENT_BINARY_DIR}/fdb5_version.c
	LibFdb5.h
	LibFdb5.cc

    api/fdb_c.cc
    api/fdb_c.h
    api/DistFDB.cc
    api/DistFDB.h
    api/FDB.cc
    api/FDB.h
    api/FDBFactory.cc
    api/FDBFactory.h
    api/FDBStats.cc
    api/FDBStats.h
    api/LocalFDB.cc
    api/LocalFDB.h
    api/RandomFDB.cc
    api/SelectFDB.cc
    api/SelectFDB.h

    api/helpers/APIIterator.h
    api/helpers/AxesIterator.cc
    api/helpers/AxesIterator.h
    api/helpers/ControlIterator.cc
    api/helpers/ControlIterator.h
    api/helpers/FDBToolRequest.cc
    api/helpers/FDBToolRequest.h
    api/helpers/DumpIterator.h
    api/helpers/ListElement.cc
    api/helpers/ListElement.h
    api/helpers/ListIterator.h
    api/helpers/LockIterator.h
    api/helpers/MoveIterator.h
    api/helpers/StatusIterator.h
    api/helpers/WipeIterator.h
    api/helpers/PurgeIterator.h
    api/helpers/StatsIterator.cc
    api/helpers/StatsIterator.h
    api/helpers/Callback.h

    api/local/QueryVisitor.h
    api/local/QueueStringLogTarget.h
    api/local/ListVisitor.h
    api/local/AxesVisitor.cc
    api/local/AxesVisitor.h
    api/local/ControlVisitor.cc
    api/local/ControlVisitor.h
    api/local/DumpVisitor.h
    api/local/WipeVisitor.cc
    api/local/WipeVisitor.h
    api/local/MoveVisitor.cc
    api/local/MoveVisitor.h
    api/local/PurgeVisitor.cc
    api/local/PurgeVisitor.h
    api/local/StatsVisitor.cc
    api/local/StatsVisitor.h
    api/local/StatusVisitor.h

    config/Config.cc
    config/Config.h
    database/Archiver.cc
    database/Archiver.h
    database/ArchiveVisitor.cc
    database/ArchiveVisitor.h
    database/AxisRegistry.cc
    database/AxisRegistry.h
    database/BaseArchiveVisitor.cc
    database/BaseArchiveVisitor.h
    database/BaseKey.cc
    database/BaseKey.h
    database/Catalogue.cc
    database/Catalogue.h
    database/DatabaseNotFoundException.cc
    database/DatabaseNotFoundException.h
    database/DataStats.cc
    database/DataStats.h
    database/DbStats.cc
    database/DbStats.h
    database/Engine.cc
    database/Engine.h
    database/EntryVisitMechanism.cc
    database/EntryVisitMechanism.h
    database/Field.cc
    database/Field.h
    database/FieldDetails.cc
    database/FieldDetails.h
    database/FieldLocation.cc
    database/FieldLocation.h
    database/UriStore.cc
    database/UriStore.h
    database/Indexer.cc
    database/Indexer.h
    database/Index.cc
    database/Index.h
    database/IndexLocation.cc
    database/IndexLocation.h
    database/IndexStats.cc
    database/IndexStats.h
    database/Inspector.cc
    database/Inspector.h
    database/StatsReportVisitor.cc
    database/StatsReportVisitor.h
    database/Store.cc
    database/Store.h
    database/PurgeVisitor.cc
    database/PurgeVisitor.h
    database/WipeVisitor.cc
    database/WipeVisitor.h
    database/MoveVisitor.cc
    database/MoveVisitor.h
    database/IndexAxis.cc
    database/IndexAxis.h
    database/IndexFactory.cc
    database/IndexFactory.h
    database/Key.cc
    database/Key.h
    database/ReadVisitor.cc
    database/ReadVisitor.h
    database/Report.cc
    database/Report.h
    database/RetrieveVisitor.cc
    database/RetrieveVisitor.h
    database/MultiRetrieveVisitor.cc
    database/MultiRetrieveVisitor.h
    database/WriteVisitor.cc
    database/WriteVisitor.h
    database/Notifier.cc
    database/Notifier.h
    database/Manager.cc
    database/Manager.h
    message/MessageArchiver.cc
    message/MessageArchiver.h
    message/MessageDecoder.cc
    message/MessageDecoder.h
    message/MessageIndexer.cc
    message/MessageIndexer.h
    io/FDBFileHandle.cc
    io/FDBFileHandle.h
    io/LustreSettings.cc
    io/LustreSettings.h
    io/LustreFileHandle.h
    io/HandleGatherer.cc
    io/HandleGatherer.h
    rules/MatchAlways.cc
    rules/MatchAlways.h
    rules/MatchAny.cc
    rules/MatchAny.h
    rules/Matcher.cc
    rules/Matcher.h
    rules/MatchHidden.cc
    rules/MatchHidden.h
    rules/MatchOptional.cc
    rules/MatchOptional.h
    rules/MatchValue.cc
    rules/MatchValue.h
    rules/Predicate.cc
    rules/Predicate.h
    rules/Rule.cc
    rules/Rule.h
    rules/Schema.cc
    rules/Schema.h
    rules/SchemaParser.cc
    rules/SchemaParser.h
    tools/FDBTool.cc
    tools/FDBTool.h
    tools/FDBVisitTool.cc
    tools/FDBVisitTool.h
    types/Type.cc
    types/Type.h
    types/TypeAbbreviation.cc
    types/TypeAbbreviation.h
    types/TypeClimateDaily.cc
    types/TypeClimateDaily.h
    types/TypeClimateMonthly.cc
    types/TypeClimateMonthly.h
    types/TypeDate.cc
    types/TypeDate.h
    types/TypeDefault.cc
    types/TypeDefault.h
    types/TypeDouble.cc
    types/TypeDouble.cc
    types/TypeDouble.h
    types/TypeDouble.h
    types/TypeExpver.cc
    types/TypeExpver.h
    types/TypeGrid.cc
    types/TypeGrid.h
    types/TypeIgnore.cc
    types/TypeIgnore.h
    types/TypeInteger.cc
    types/TypeInteger.h
    types/TypeMonth.cc
    types/TypeMonth.h
    types/TypeYear.cc
    types/TypeYear.h
    types/TypeParam.cc
    types/TypeParam.h
    types/TypesFactory.cc
    types/TypesFactory.h
    types/TypesRegistry.cc
    types/TypesRegistry.h
    types/TypeStep.cc
    types/TypeStep.h
    types/TypeTime.cc
    types/TypeTime.h
)

if(HAVE_FDB_REMOTE)
    list( APPEND fdb5_srcs
        api/RemoteFDB.cc
        api/RemoteFDB.h

        remote/Connection.h
        remote/Connection.cc
        remote/RemoteFieldLocation.h
        remote/RemoteFieldLocation.cc
        remote/Messages.h
        remote/Messages.cc
        remote/FdbServer.h
        remote/FdbServer.cc

        remote/client/Client.h
        remote/client/Client.cc
        remote/client/ClientConnection.h
        remote/client/ClientConnection.cc
        remote/client/ClientConnectionRouter.h
        remote/client/ClientConnectionRouter.cc
        remote/client/RemoteStore.cc
        remote/client/RemoteStore.h
        remote/client/RemoteCatalogue.h
        remote/client/RemoteCatalogue.cc

        remote/server/AvailablePortList.cc
        remote/server/AvailablePortList.h
        remote/server/CatalogueHandler.h
        remote/server/CatalogueHandler.cc
        remote/server/StoreHandler.h
        remote/server/StoreHandler.cc
        remote/server/ServerConnection.h
        remote/server/ServerConnection.cc
    )
endif()

if(fdb5_HAVE_LUSTRE)
  list( APPEND fdb5_srcs io/fdb5_lustreapi_file_create.c )
endif()

if ( HAVE_GRIB )
    list( APPEND fdb5_srcs
        io/SingleGribMungePartFileHandle.cc
        io/SingleGribMungePartFileHandle.h
    )
endif()

if( HAVE_TOCFDB )
    list( APPEND fdb5_srcs
        toc/AdoptVisitor.cc
        toc/AdoptVisitor.h
        toc/BTreeIndex.cc
        toc/BTreeIndex.h
        toc/Root.cc
        toc/Root.h
        toc/FieldRef.cc
        toc/FieldRef.h
        toc/FileSpaceHandler.cc
        toc/FileSpaceHandler.h
        toc/FileSpace.cc
        toc/FileSpace.h
        toc/ExpverFileSpaceHandler.cc
        toc/ExpverFileSpaceHandler.h
        toc/EnvVarFileSpaceHandler.cc
        toc/EnvVarFileSpaceHandler.h
        toc/RootManager.cc
        toc/RootManager.h
        toc/TocCommon.cc
        toc/TocCommon.h
        toc/TocCatalogue.cc
        toc/TocCatalogue.h
        toc/TocCatalogueReader.cc
        toc/TocCatalogueReader.h
        toc/TocCatalogueWriter.cc
        toc/TocCatalogueWriter.h
        toc/TocFieldLocation.cc
        toc/TocFieldLocation.h
        toc/TocHandler.cc
        toc/TocHandler.h
        toc/TocIndex.cc
        toc/TocIndex.h
        toc/TocIndexLocation.cc
        toc/TocIndexLocation.h
        toc/TocPurgeVisitor.cc
        toc/TocPurgeVisitor.h
        toc/TocSerialisationVersion.cc
        toc/TocSerialisationVersion.h
        toc/TocWipeVisitor.cc
        toc/TocWipeVisitor.h
        toc/TocMoveVisitor.cc
        toc/TocMoveVisitor.h
        toc/TocRecord.cc
        toc/TocRecord.h
        toc/TocStats.cc
        toc/TocStats.h
        toc/TocStore.cc
        toc/TocStore.h
        toc/TocEngine.cc
        toc/TocEngine.h
        )

    list( APPEND fdb5_tools
        fdb-wipe
        fdb-stats
        fdb-purge
        fdb-dump-toc
        fdb-dump-index
        fdb-move
        fdb-reconsolidate-toc )
endif()

if( HAVE_RADOSFDB )
    list( APPEND fdb5_srcs
        rados/RadosFieldLocation.cc
        rados/RadosFieldLocation.h
        rados/RadosStore.cc
        rados/RadosStore.h
    )
endif()

if( HAVE_DAOSFDB )
    list( APPEND fdb5_srcs
        daos/DaosOID.cc
        daos/DaosOID.h
        daos/DaosName.cc
        daos/DaosName.h
        daos/DaosObject.cc
        daos/DaosObject.h
        daos/DaosContainer.cc
        daos/DaosContainer.h
        daos/DaosPool.cc
        daos/DaosPool.h
        daos/DaosSession.cc
        daos/DaosSession.h
        daos/DaosArrayHandle.cc
        daos/DaosArrayHandle.h
        daos/DaosKeyValueHandle.cc
        daos/DaosKeyValueHandle.h
        daos/DaosStore.h
        daos/DaosStore.cc
        daos/DaosFieldLocation.h
        daos/DaosFieldLocation.cc
        daos/DaosException.h
        daos/DaosException.cc
        daos/DaosEngine.h
        daos/DaosEngine.cc
        daos/DaosCatalogue.h
        daos/DaosCatalogue.cc
        daos/DaosCatalogueWriter.h
        daos/DaosCatalogueWriter.cc
        daos/DaosCatalogueReader.h
        daos/DaosCatalogueReader.cc
        daos/DaosIndex.h
        daos/DaosIndex.cc
        daos/DaosIndexLocation.h
        daos/DaosIndexLocation.cc
        daos/DaosCommon.h
        daos/DaosCommon.cc
        daos/DaosWipeVisitor.h
        daos/DaosWipeVisitor.cc
        daos/DaosArrayPartHandle.h
        daos/DaosArrayPartHandle.cc
        daos/DaosLazyFieldLocation.h
        daos/DaosLazyFieldLocation.cc
        daos/UUID.h
        daos/UUID.cc
    )
else()
    set( DAOS_LIBRARIES "" )
    set( DAOS_INCLUDE_DIRS "" )
    set( UUID_LIBRARIES "" )
    set( UUID_INCLUDE_DIRS "" )
endif()

ecbuild_add_library(

    TARGET  fdb5

    TYPE SHARED # Library needs to be shared for dynamic factory self registration

    SOURCES
        ${fdb5_srcs}

    INSTALL_HEADERS LISTED

    HEADER_DESTINATION
        ${INSTALL_INCLUDE_DIR}/fdb5

    PUBLIC_INCLUDES
        $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>

    PUBLIC_LIBS
        metkit
        eckit
        eckit_option
        "${UUID_LIBRARIES}"

    PRIVATE_INCLUDES
        "${LUSTREAPI_INCLUDE_DIRS}"
        "${DAOS_INCLUDE_DIRS}"
        "${DAOS_TESTS_INCLUDE_DIRS}"

    PRIVATE_LIBS
        ${grib_handling_pkg}
        ${LUSTREAPI_LIBRARIES}
        "${DAOS_LIBRARIES}"
        "${DAOS_TESTS_LIBRARIES}"
)

if(HAVE_FDB_BUILD_TOOLS)

  list( APPEND fdb5_scripts fdb fdb-which )

  foreach( _script ${fdb5_scripts} )
    configure_file(scripts/${_script}.in ${CMAKE_BINARY_DIR}/bin/${_script} @ONLY)
    install(PROGRAMS ${CMAKE_BINARY_DIR}/bin/${_script} DESTINATION ${INSTALL_BIN_DIR} )
  endforeach()
endif()

list( APPEND fdb5_tools
    fdb-axes
    fdb-write
    fdb-copy
    fdb-dump
    fdb-list
    fdb-read
    fdb-schema
    fdb-where
    fdb-info
    fdb-inspect
    fdb-status
    fdb-lock
    fdb-unlock
)

if ( HAVE_GRIB )
    list( APPEND fdb5_tools
        fdb-hammer
        fdb-patch
    )
endif()

if ( HAVE_TOCFDB )
    list(APPEND fdb5_tools
        fdb-root
        fdb-overlay
        fdb-hide
    )
endif()

foreach( _tool ${fdb5_tools} )

  ecbuild_add_executable( TARGET    ${_tool}
                          CONDITION HAVE_FDB_BUILD_TOOLS
                          SOURCES   tools/${_tool}.cc

=== tests/fdb/tools/CMakeLists.txt ===
list( APPEND fdb_tools_tests
    fdb_info )

foreach( _t ${fdb_tools_tests} )

    configure_file( ${_t}.sh.in ${_t}.sh @ONLY )

    ecbuild_add_test(
        TYPE SCRIPT
        CONDITION HAVE_FDB_BUILD_TOOLS
        COMMAND ${_t}.sh)

endforeach()

list( APPEND fdb_tools_grib_tests
    fdb_axes )

foreach( _t ${fdb_tools_grib_tests} )
    
    configure_file( ${_t}.sh.in ${_t}.sh @ONLY )

    ecbuild_add_test(
        TYPE SCRIPT
        CONDITION HAVE_FDB_BUILD_TOOLS AND HAVE_GRIB
        ENVIRONMENT ECCODES_BINARY_PATH=$<TARGET_FILE_DIR:grib_set>
        COMMAND ${_t}.sh)

endforeach()

add_subdirectory( auxiliary )

add_subdirectory( list )

add_subdirectory( inspect )

=== tests/fdb/tools/list/CMakeLists.txt ===
set(test_name fdb_list)

configure_file( ${test_name}.sh.in ${test_name}.sh @ONLY )

ecbuild_add_test(
    TYPE SCRIPT
    CONDITION HAVE_FDB_BUILD_TOOLS
    COMMAND ${test_name}.sh)

=== debian/changelog ===
fdb (5.14.0-1) unstable; urgency=medium

  * Drop kfreebsd, ia64 support
  * New upstream  release
  * Now depend on libeckit-dev >=1.25.0-1~, libmetkit-dev >= 1.12.0-1~

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 04 Feb 2025 03:32:04 +0000

## fdb 5.15.3

=== debian/changelog ===
fdb (5.15.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 13 Feb 2025 17:08:03 +0000

fdb (5.15.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 10 Feb 2025 09:09:23 +0000

fdb (5.15.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 09 Feb 2025 10:00:38 +0000

## fdb 5.15.4

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.7 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)

project( fdb5 LANGUAGES C CXX )

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

CHECK_TYPE_SIZE(off_t SIZEOF_OFF_T)

if ("${SIZEOF_OFF_T}" LESS 8)
    MESSAGE(SEND_ERROR "Missing support for large files (off_t size < 64 bits)")
endif()

########################################################################################################################
### dependencies and options

### eckit

set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support

ecbuild_find_package( NAME eckit  VERSION 1.28.3 REQUIRED )

### GRIB support

ecbuild_find_package( NAME eccodes VERSION 2.10 QUIET )

ecbuild_add_option( FEATURE GRIB
                    DEFAULT ON
                    CONDITION eccodes_FOUND
                    DESCRIPTION "Support for GRIB via eccodes")

ecbuild_find_package( NAME metkit VERSION 1.11.22 REQUIRED )

### FDB backend in CEPH object store (using Rados)

find_package( RADOS QUIET )
ecbuild_add_option( FEATURE RADOSFDB  # option defined in fdb5_config.h
                    CONDITION eckit_HAVE_RADOS AND RADOS_FOUND
                    DEFAULT OFF
                    DESCRIPTION "Ceph/Rados support for FDB Store" )

### FDB backend in indexed filesystem with table-of-contents, i.e. TOC
### Supports Lustre parallel filesystem stripping control

ecbuild_add_option( FEATURE TOCFDB  # option defined in fdb5_config.h
                    DEFAULT ON
                    DESCRIPTION "Filesystem TOC support for FDB" )

### support for Lustre API control of file stripping

find_package( LUSTREAPI QUIET )

ecbuild_add_option( FEATURE LUSTRE  # option defined in fdb5_config.h
                    CONDITION LUSTREAPI_FOUND
                    DEFAULT ON
                    DESCRIPTION "Support for Lustre API control of file stripping " )

### experimental & sandbox features

ecbuild_add_option( FEATURE FDB_REMOTE
                    DEFAULT ON
                    DESCRIPTION "Support for FDB remote access" )

find_package(UUID QUIET)

find_package(DAOS QUIET)

set(_default_dummy_daos ON)
if(DAOS_FOUND)
    set(_default_dummy_daos OFF)
endif()

ecbuild_add_option( FEATURE DUMMY_DAOS
                    DEFAULT ${_default_dummy_daos}
                    CONDITION UUID_FOUND
                    DESCRIPTION "Use dummy DAOS library emulating DAOS with a file system" )

if(HAVE_DUMMY_DAOS)
    set(DAOS_LIBRARIES dummy_daos)
    set(DAOS_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/src/dummy_daos)
    set(DAOS_FOUND TRUE)
    set(DAOS_TESTS_LIBRARIES dummy_daos_tests)
    set(DAOS_TESTS_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/src/dummy_daos)
    set(DAOS_TESTS_FOUND TRUE)
endif()

ecbuild_add_option( FEATURE DAOSFDB
                    CONDITION DAOS_FOUND AND UUID_FOUND 
                    DEFAULT ON
                    DESCRIPTION "DAOS support for FDB Store" )

ecbuild_add_option( FEATURE DAOS_ADMIN
                    DEFAULT ${_default_dummy_daos}
                    CONDITION HAVE_DAOSFDB AND DAOS_TESTS_FOUND
                    DESCRIPTION "Add features for DAOS pool management. Removes need to manually create a pool for DAOS unit tests" )

# DAOS_TESTS is a daos admin library, usually not present
if(NOT HAVE_DAOS_ADMIN)
    set( DAOS_TESTS_LIBRARIES "" )
    set( DAOS_TESTS_INCLUDE_DIRS "" )
endif()

ecbuild_add_option( FEATURE EXPERIMENTAL
                    DEFAULT OFF
                    DESCRIPTION "Experimental features" )

ecbuild_add_option( FEATURE SANDBOX
                    DESCRIPTION "build the sandbox stuff"
                    DEFAULT OFF	 )

### build the tools

ecbuild_add_option( FEATURE BUILD_TOOLS
                    DEFAULT ON
                    DESCRIPTION "Build the command line tools" )

if(HAVE_BUILD_TOOLS)
    set(_default_fdb_tools ON)
else()
    set(_default_fdb_tools OFF)
endif()

ecbuild_add_option( FEATURE FDB_BUILD_TOOLS
                    DEFAULT ${_default_fdb_tools}
                    DESCRIPTION "Build the command line FDB tools" )

### find thread library ( preferably pthreads )

set( CMAKE_THREAD_PREFER_PTHREAD 1 )
find_package(Threads REQUIRED)

### checks

# check thread library is pthreads

if( NOT ${CMAKE_USE_PTHREADS_INIT} )
	message( FATAL_ERROR "Only pthreads supported - thread library found is [${CMAKE_THREAD_LIBS_INIT}]" )
endif()

########################################################################################################################
# contents

include(cmake/compiler_warnings.cmake) # optionally handle compiler specific warnings

set( fdb5_INCLUDE_DIRS  ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )

include_directories( ${fdb5_INCLUDE_DIRS} )

set_directory_properties( PROPERTIES COMPILE_DEFINITIONS "${ECKIT_DEFINITIONS};${ECCODES_DEFINITIONS}" )

get_directory_property( fdb5_DEFINITIONS COMPILE_DEFINITIONS )

### source files

add_subdirectory( src )
add_subdirectory( tests )

### finalize


ecbuild_install_project( NAME fdb )

ecbuild_print_summary()

=== src/fdb5/CMakeLists.txt ===
--- 
+++ 
@@ -129,6 +129,10 @@
     database/Key.h
     database/ReadVisitor.cc
     database/ReadVisitor.h
+    database/ReindexVisitor.cc
+    database/ReindexVisitor.h
+    database/Reindexer.cc
+    database/Reindexer.h
     database/Report.cc
     database/Report.h
     database/RetrieveVisitor.cc
@@ -204,6 +208,8 @@
     types/TypeInteger.h
     types/TypeMonth.cc
     types/TypeMonth.h
+    types/TypeMonthOfDate.cc
+    types/TypeMonthOfDate.h
     types/TypeYear.cc
     types/TypeYear.h
     types/TypeParam.cc
@@ -452,6 +458,7 @@
     fdb-status
     fdb-lock
     fdb-unlock
+    fdb-reindex
 )
 
 if ( HAVE_GRIB )
@@ -469,8 +476,3 @@
     )
 endif()
 
-foreach( _tool ${fdb5_tools} )
-
-  ecbuild_add_executable( TARGET    ${_tool}
-                          CONDITION HAVE_FDB_BUILD_TOOLS
-                          SOURCES   tools/${_tool}.cc

=== tests/regressions/CMakeLists.txt ===
if (HAVE_FDB_BUILD_TOOLS) # test scripts use the fdb tools

    if (HAVE_GRIB)
        add_subdirectory(FDB-238)
        add_subdirectory(FDB-239)
        add_subdirectory(FDB-240)
        add_subdirectory(FDB-243)
        add_subdirectory(FDB-245)
        add_subdirectory(FDB-251)
        add_subdirectory(FDB-258)
        add_subdirectory(FDB-260)
        add_subdirectory(FDB-264)
        add_subdirectory(FDB-266)
        add_subdirectory(FDB-267)
        add_subdirectory(FDB-268)
        add_subdirectory(FDB-271)
        add_subdirectory(FDB-275)
        add_subdirectory(FDB-276)
        add_subdirectory(FDB-282)
        add_subdirectory(FDB-291)
        add_subdirectory(FDB-292)
        add_subdirectory(FDB-303)
        add_subdirectory(FDB-307)
        add_subdirectory(FDB-310)
        add_subdirectory(FDB-332)
    endif()

    add_subdirectory(FDB-241)

endif()

=== tests/fdb/api/CMakeLists.txt ===
### test data files
list( APPEND fdb_api_test_data_files
x138-300.grib
x138-400.grib
y138-400.grib
)

list( APPEND _test_environment
    FDB_HOME=${PROJECT_BINARY_DIR} )

if(ECCODES_DEFINITION_PATH AND (EXISTS ${ECCODES_DEFINITION_PATH}))
    list( APPEND _test_environment 
        ECCODES_DEFINITION_PATH=${ECCODES_DEFINITION_PATH})
endif()

if(ECCODES_SAMPLES_PATH AND (EXISTS ${ECCODES_SAMPLES_PATH}))
    list( APPEND _test_environment 
    ECCODES_SAMPLES_PATH=${ECCODES_SAMPLES_PATH})
endif()
    
ecbuild_get_test_multidata( TARGET get_fdb_api_test_data
                            NAMES ${fdb_api_test_data_files}
                            NOCHECK )

list( APPEND api_tests
    config
    select
    dist
    fdb_c
    callback
    auxiliary
)

foreach( _test ${api_tests} )

    ecbuild_add_test( TARGET test_fdb5_api_${_test}
                      SOURCES test_${_test}.cc
                      TEST_DEPENDS get_fdb_api_test_data
                      LIBS fdb5
                      ENVIRONMENT "${_test_environment}" )

endforeach()

=== tests/fdb/tools/CMakeLists.txt ===
--- 
+++ 
@@ -28,8 +28,7 @@
 endforeach()
 
 add_subdirectory( auxiliary )
+add_subdirectory( list )
+add_subdirectory( inspect )
+add_subdirectory( reindex )
 
-add_subdirectory( list )
-
-add_subdirectory( inspect )
-

=== tests/regressions/FDB-240/CMakeLists.txt ===
ecbuild_configure_file( FDB-240.sh.in FDB-240.sh @ONLY )
ecbuild_get_test_multidata(TARGET download_fdb5_regression_tests_files NAMES sh.300.grib )

ecbuild_add_test(
    TYPE     SCRIPT
    TEST_DEPENDS download_fdb5_regression_tests_files
    COMMAND  FDB-240.sh )

=== tests/regressions/FDB-241/CMakeLists.txt ===
if( metkit_HAVE_ODB AND TARGET odc )

ecbuild_configure_file( FDB-241.sh.in FDB-241.sh @ONLY ) # needs metkit_HAVE_ODB
ecbuild_add_test(
    TYPE     SCRIPT
    COMMAND  FDB-241.sh )

endif()

=== tests/regressions/FDB-243/CMakeLists.txt ===
ecbuild_configure_file( FDB-243.sh.in FDB-243.sh @ONLY )
ecbuild_add_test(
    TYPE     SCRIPT
    COMMAND  FDB-243.sh )

=== tests/regressions/FDB-245/CMakeLists.txt ===
ecbuild_configure_file( FDB-245.sh.in FDB-245.sh @ONLY )
ecbuild_add_test(
    TYPE     SCRIPT
    COMMAND  FDB-245.sh )

=== tests/regressions/FDB-258/CMakeLists.txt ===
if(HAVE_FDB_REMOTE)

ecbuild_configure_file( FDB-258.sh.in FDB-258.sh @ONLY )

ecbuild_add_test(
    TYPE      SCRIPT
    CONDITION HAVE_EXTRA_TESTS
    COMMAND   FDB-258.sh )

endif()

=== tests/regressions/FDB-271/CMakeLists.txt ===
ecbuild_configure_file( FDB-271.sh.in FDB-271.sh @ONLY )

CHECK_TYPE_SIZE(off_t SIZEOF_OFF_T)

if ("${SIZEOF_OFF_T}" LESS 8)
    ecbuild_add_test(
        TYPE     SCRIPT
        COMMAND  FDB-271.sh )
endif()

=== tests/fdb/tools/list/CMakeLists.txt ===
# get test data for the list tests
ecbuild_get_test_multidata( TARGET get_fdb_test_data_list LABELS list NAMES "od.oper.grib" )

# list of tests
list( APPEND fdb_tools_list_tests
    all
    all_full
    location
    masking
    minimum_keys
    porcelain
    ranges
    depth
)

# add the tests
foreach( _test ${fdb_tools_list_tests} )

    configure_file( list_${_test}.sh.in list_${_test}.sh @ONLY )

    ecbuild_add_test(
        TARGET test_fdb_tools_list_${_test}
        TYPE SCRIPT
        LABELS list
        CONDITION HAVE_FDB_BUILD_TOOLS
        TEST_DEPENDS get_fdb_test_data_list
        COMMAND list_${_test}.sh )

endforeach( )

=== debian/changelog ===
fdb (5.15.4-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 21 Feb 2025 18:32:59 +0000

=== debian/control ===
Source: fdb
Section: utils
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (=13),
 architecture-is-64-bit,
 ecbuild (>= 3.3.0-3),
 libeckit-dev (>= 1.25.0-1~),
 libeccodes-dev,
 libopenjp2-7-dev,
 libmetkit-dev (>= 1.12.0-1~),
 libmetkit-utils ,
 libodc-dev,
 libpmem-dev [amd64 arm64 ppc64el riscv64],
 librados-dev [!sparc64 !ppc64 !alpha !loong64],
 libeccodes-tools
Standards-Version: 4.7.0
Homepage: https://github.com/ecmwf/fdb
Vcs-Browser: https://salsa.debian.org/science-team/fdb.git
Vcs-Git: https://salsa.debian.org/science-team/fdb.git -b debian/latest

Package: libfdb5-0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Library for the ECMWF Fields Database
 FDB (Fields DataBase) is a domain-specific object store developed
 at ECMWF for storing, indexing and retrieving GRIB data. 
 Each GRIB message is stored as a field and indexed trough semantic metadata
 (i.e. physical variables such as temperature, pressure, ...).
 A set of fields can be retrieved specifying a request using
 a specific language developed for accessing the MARS Archive.

Package: libfdb5-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libfdb5-0d (= ${binary:Version}), 
  ${misc:Depends}, libeckit-dev
Recommends: pkgconf
Description: Development files for the ECMWF Fields database
 FDB (Fields DataBase) is a domain-specific object store developed
 at ECMWF for storing, indexing and retrieving GRIB data. 
 Each GRIB message is stored as a field and indexed trough semantic metadata
 (i.e. physical variables such as temperature, pressure, ...).
 A set of fields can be retrieved specifying a request using
 a specific language developed for accessing the MARS Archive.
 .
 This package provides shared libraries and headers.

Package: fdb5
Multi-Arch: foreign
Architecture: any
Depends: libfdb5-0d ( = ${binary:Version}), 
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libfdb5-dev (= ${binary:Version})
Description: Utilities for the FDB Fields Database
 FDB (Fields DataBase) is a domain-specific object store developed
 at ECMWF for storing, indexing and retrieving GRIB data. 
 Each GRIB message is stored as a field and indexed trough semantic metadata
 (i.e. physical variables such as temperature, pressure, ...).
 A set of fields can be retrieved specifying a request using
 a specific language developed for accessing the MARS Archive.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

ARCH:=$(shell dpkg --print-architecture)
LIBDIR:=/usr/lib/${DEB_HOST_MULTIARCH}
DESTDIR:=$(CURDIR)/debian/tmp
BUILDDIR:=debian/build

ARCH_PMEM:= amd64 arm64 ppc64el
DO_PMEM:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_PMEM)),ON,OFF)

ARCH_NORADOS:= alpha loong64 ppc64 sparc64
DO_RADOS:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_NORADOS)),OFF,ON)

# The magic debhelper  rule
%:
	dh $@ --buildsystem=ecbuild --builddirectory=$(BUILDDIR)


# Disable for now
BUILD_FLAGS:=  -DENABLE_RPATHS=OFF \
		-DENABLE_RELATIVE_RPATHS=OFF \
		-DENABLE_PMEMFDB=OFF \
		-DENABLE_RADOSFDB=OFF \
		-DENABLE_LUSTRE=OFF 

override_dh_auto_configure:
	mkdir -p  $(BUILDDIR)/data  
	( cd $(BUILDDIR)/data ; tar axpf $(CURDIR)/../fdb_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )
	dh_auto_configure -- \
		      ${BUILD_FLAGS}


override_dh_auto_install:
	dh_auto_install --builddirectory=debian/build
	# Fixup cmake files. Hack. can we do better with patches to upstream ?
	sed -i -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' $(DESTDIR)/$(LIBDIR)/cmake/fdb5/fdb5-targets.cmake

override_dh_auto_test:
	LD_LIBRARY_PATH=$(BUILDDIR)/lib dh_auto_test ||  echo "Ignoring test failures" 

override_dh_fixperms-arch:
	chrpath -d debian/fdb5/usr/bin/fdb-move
	dh_fixperms

=== debian/watch ===
version=3
opts="uversionmangle=s/-rc/~rc/, filenamemangle=s/.+\/(\d\S+)\.tar\.gz/$1\.tar\.gz/" \
  https://github.com/ecmwf/fdb/tags .*/v?(\d\d?\d?\..+).tar\.gz

## fdb 5.15.9

=== src/fdb5/CMakeLists.txt ===
--- 
+++ 
@@ -158,6 +158,8 @@
     io/LustreFileHandle.h
     io/HandleGatherer.cc
     io/HandleGatherer.h
+    io/FieldHandle.cc
+    io/FieldHandle.h
     rules/MatchAlways.cc
     rules/MatchAlways.h
     rules/MatchAny.cc
@@ -472,7 +474,3 @@
     list(APPEND fdb5_tools
         fdb-root
         fdb-overlay
-        fdb-hide
-    )
-endif()
-

=== debian/changelog ===
fdb (5.15.9-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.7.2
  * Use PMEM on appropriate archs
  * Change dependence on libeckit to pull in RADOS support
  * Update arch support for RADOS
  * rados.patch: compile changes needed for FileStore -> URIStore
     Under development; currently disabled

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 10 Mar 2025 12:47:31 +0000

## fdb 5.15.11

=== src/fdb5/CMakeLists.txt ===
--- 
+++ 
@@ -250,6 +250,8 @@
         remote/client/RemoteStore.h
         remote/client/RemoteCatalogue.h
         remote/client/RemoteCatalogue.cc
+        remote/client/ReadLimiter.h
+        remote/client/ReadLimiter.cc
 
         remote/server/AvailablePortList.cc
         remote/server/AvailablePortList.h
@@ -471,6 +473,3 @@
 endif()
 
 if ( HAVE_TOCFDB )
-    list(APPEND fdb5_tools
-        fdb-root
-        fdb-overlay

=== tests/regressions/CMakeLists.txt ===
--- 
+++ 
@@ -26,5 +26,9 @@
     endif()
 
     add_subdirectory(FDB-241)
+    add_subdirectory(FDB-419)
 
 endif()
+
+# Tests not using the fdb tools
+add_subdirectory(FDB-425)

=== debian/changelog ===
fdb (5.15.11-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 22 Mar 2025 09:28:50 +0000

## fdb 5.15.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,11 @@
 
 ########################################################################################################################
 ### dependencies and options
+
+### Documentation
+ecbuild_add_option( FEATURE FDB_DOCUMENTATION 
+                    DEFAULT OFF
+                    DESCRIPTION "Enable documentation generation" )
 
 ### eckit
 
@@ -158,6 +163,9 @@
 add_subdirectory( tests )
 
 ### finalize
+if(ENABLE_FDB_DOCUMENTATION)
+    add_subdirectory(docs)
+endif()
 
 
 ecbuild_install_project( NAME fdb )

=== docs/CMakeLists.txt ===
find_package(Doxygen 1.13 REQUIRED)
find_package(Sphinx REQUIRED)

file(GLOB_RECURSE FDB_PUBLIC_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/../src/fdb5/api/*.h)

set(DOXYGEN_INPUT_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../src/fdb5/api)
set(DOXYGEN_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/doxygen)
set(DOXYGEN_INDEX_FILE ${DOXYGEN_OUTPUT_DIR}/html/index.html)
set(DOXYFILE_IN ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)
set(DOXYFILE_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

configure_file(${DOXYFILE_IN} ${DOXYFILE_OUT} @ONLY)

add_custom_command(
    OUTPUT ${DOXYGEN_INDEX_FILE}
    DEPENDS ${FDB_PUBLIC_HEADERS}
    COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE_OUT}
    MAIN_DEPENDENCY ${DOXYFILE_OUT} ${DOXYFILE_IN}
    COMMENT "Extracting documentation with doxygen")

add_custom_target(fdb-doxygen ALL DEPENDS ${DOXYGEN_INDEX_FILE})

set(SPHINX_SOURCE ${CMAKE_CURRENT_SOURCE_DIR})
set(SPHINX_BUILD ${CMAKE_CURRENT_BINARY_DIR}/sphinx)
set(SPHINX_INDEX_FILE ${SPHINX_BUILD}/index.html)

file(GLOB_RECURSE SPHINX_INPUT_FILES ${CMAKE_CURRENT_SOURCE_DIR}/*.rst)

add_custom_command(
    OUTPUT ${SPHINX_INDEX_FILE}
    COMMAND
        ${SPHINX_EXECUTABLE} -b html -j auto
        -Dbreathe_projects.FDB=${DOXYGEN_OUTPUT_DIR}/xml
        -Dversion=${fdb5_VERSION_STR}
        -Drelease=${fdb5_VERSION_STR}
    VERBATIM
    ${SPHINX_SOURCE} ${SPHINX_BUILD}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS
        ${SPHINX_INPUT_FILES}
        ${DOXYGEN_INDEX_FILE}
        MAIN_DEPENDENCY ${SPHINX_SOURCE}/conf.py
        COMMENT "Generating documentation with Sphinx"
)

add_custom_target(fdb-doc ALL DEPENDS ${SPHINX_INDEX_FILE})

=== docs/requirements.txt ===
Sphinx~=8.1
sphinx-book-theme~=1.1
breathe~=4.35

=== tests/CMakeLists.txt ===
# unit tests

include_directories( ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )

add_subdirectory( fdb )
add_subdirectory( regressions )

=== src/dummy_daos/CMakeLists.txt ===
ecbuild_add_library(

    TARGET dummy_daos

    INSTALL_HEADERS_LIST
        daos.h

    HEADER_DESTINATION ${INSTALL_INCLUDE_DIR}

    SOURCES
        daos.h
        daos.cc
        dummy_daos.h
        dummy_daos.cc

    PUBLIC_LIBS
        eckit
        uuid

)

if(HAVE_DAOS_ADMIN)

    ecbuild_add_library(

        TARGET dummy_daos_tests

        INSTALL_HEADERS LISTED

        HEADER_DESTINATION ${INSTALL_INCLUDE_DIR}

        SOURCES
            daos/tests_lib.h
            daos/tests_lib.cc
        
        PRIVATE_INCLUDES
            ${PROJECT_SOURCE_DIR}/../daos.h
            ${PROJECT_SOURCE_DIR}/../dummy_daos.h

        PRIVATE_LIBS
            dummy_daos

    )
    
endif()

=== src/fdb5/CMakeLists.txt ===
--- 
+++ 
@@ -41,6 +41,7 @@
     api/helpers/DumpIterator.h
     api/helpers/ListElement.cc
     api/helpers/ListElement.h
+    api/helpers/ListIterator.cc
     api/helpers/ListIterator.h
     api/helpers/LockIterator.h
     api/helpers/MoveIterator.h
@@ -470,6 +471,3 @@
         fdb-hammer
         fdb-patch
     )
-endif()
-
-if ( HAVE_TOCFDB )

=== tests/fdb/CMakeLists.txt ===
configure_file( etc/mars/wind       ${PROJECT_BINARY_DIR}/etc/mars/wind       @ONLY )

configure_file( etc/fdb/config.yaml ${PROJECT_BINARY_DIR}/etc/fdb/config.yaml @ONLY )
configure_file( etc/fdb/schema      ${PROJECT_BINARY_DIR}/etc/fdb/schema      @ONLY )
#configure_file( etc/fdb/engines  ${CMAKE_BINARY_DIR}/etc/fdb/engines   @ONLY )

file( MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/tests/fdb/root ) # as defined in ${CMAKE_BINARY_DIR}/etc/fdb/roots file
file( MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/tests/fdb/root2 ) # as defined in ${CMAKE_BINARY_DIR}/etc/fdb/roots file

file( MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/tests/fdb/pool ) # as defined in ${CMAKE_BINARY_DIR}/etc/fdb/pools file

###############################################################################
# fdb unit tests

list( APPEND _test_environment
    FDB_HOME=${PROJECT_BINARY_DIR} )

list( APPEND fdb_tests
    test_fdb5_service.cc )

foreach( _tst ${fdb_tests} )

  get_filename_component(_test_name ${_tst} NAME_WE)

  ecbuild_add_test(
      TARGET  fdb5_${_test_name}
      SOURCES  ${_tst}
      INCLUDES ${ECCODES_INCLUDE_DIRS}
      ENVIRONMENT "${_test_environment}"
      LIBS  fdb5 )

endforeach()

###############################################################################
# fdb tool tests

list( APPEND _test_data
  "rd.vod.grib"
)

ecbuild_get_test_multidata( TARGET fdb5_get_test_data NAMES ${_test_data} )

foreach( _tst ${_test_data} )

    # define tool location using cmake-generator-expressions
    # see https://cmake.org/cmake/help/v3.4/manual/cmake-generator-expressions.7.html

    ecbuild_add_test(
        TARGET  fdb5_archive_${_tst}
        CONDITION HAVE_FDB_BUILD_TOOLS AND HAVE_GRIB
        COMMAND $<TARGET_FILE:fdb-write>
        TEST_DEPENDS fdb5_get_test_data
        ARGS    ${_tst}
        ENVIRONMENT "${_test_environment}" )

      ecbuild_add_test(
          TARGET  fdb5_extract_${_tst}
          CONDITION HAVE_FDB_BUILD_TOOLS AND HAVE_GRIB
          COMMAND $<TARGET_FILE:fdb-read>
          TEST_DEPENDS fdb5_archive_${_tst}
          ARGS   --extract ${_tst} ${_tst}.2
          ENVIRONMENT "${_test_environment}" )

endforeach()

add_subdirectory( api )
add_subdirectory( database )
add_subdirectory( tools )
add_subdirectory( type )
add_subdirectory( daos )

=== tests/regressions/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,6 @@
         add_subdirectory(FDB-243)
         add_subdirectory(FDB-245)
         add_subdirectory(FDB-251)
-        add_subdirectory(FDB-258)
         add_subdirectory(FDB-260)
         add_subdirectory(FDB-264)
         add_subdirectory(FDB-266)
@@ -26,7 +25,11 @@
     endif()
 
     add_subdirectory(FDB-241)
-    add_subdirectory(FDB-419)
+
+    if (HAVE_FDB_REMOTE)
+        add_subdirectory(FDB-258)
+        add_subdirectory(FDB-419)
+    endif()
 
 endif()

=== tests/fdb/daos/CMakeLists.txt ===
if (HAVE_DUMMY_DAOS)

  list( APPEND dummy_daos_tests
    write_read
  )
  
  foreach( _test ${dummy_daos_tests} )
  
    ecbuild_add_test( TARGET test_fdb5_dummy_daos_${_test}
                      SOURCES test_dummy_daos_${_test}.cc
                      LIBS "${DAOS_LIBRARIES}" ${DAOS_TESTS_LIBRARIES} fdb5
                      INCLUDES "${DAOS_INCLUDE_DIRS}" "${DAOS_TESTS_INCLUDE_DIRS}" )
  
  endforeach()

endif()

if (HAVE_DAOSFDB)

  list( APPEND daos_tests
    daos_handle
    daos_store
    daos_catalogue
  )

  list( APPEND unit_test_libraries "${DAOS_LIBRARIES}" )
  list( APPEND unit_test_include_dirs "${DAOS_INCLUDE_DIRS}" )

  if(HAVE_DAOS_ADMIN)
    list( APPEND unit_test_libraries "${DAOS_TESTS_LIBRARIES}" )
    list( APPEND unit_test_include_dirs "${DAOS_TESTS_INCLUDE_DIRS}" )
  endif()

  list( APPEND unit_test_libraries fdb5 )

  foreach( _test ${daos_tests} )

    ecbuild_add_test( TARGET test_fdb5_daos_${_test}
                      SOURCES test_${_test}.cc
                      LIBS "${unit_test_libraries}"
                      INCLUDES "${unit_test_include_dirs}" 
                      ENVIRONMENT FDB_DAOS_DMG_CONFIG_FILE=${FDB_DAOS_DMG_CONFIG_FILE}
                      ENVIRONMENT FDB_DAOS_TEST_POOL=${FDB_DAOS_TEST_POOL} )

  endforeach()

endif()

=== tests/fdb/database/CMakeLists.txt ===

list( APPEND _test_environment
    FDB_HOME=${PROJECT_BINARY_DIR} )

ecbuild_add_test( TARGET test_fdb5_database_indexaxis
    SOURCES test_indexaxis.cc
    LIBS fdb5
    ENVIRONMENT "${_test_environment}")

=== tests/fdb/type/CMakeLists.txt ===

list( APPEND type_tests
    toKey
)

list( APPEND _test_environment
    FDB_HOME=${PROJECT_BINARY_DIR} )

foreach( _test ${type_tests} )

    ecbuild_add_test( TARGET test_fdb5_type_${_test}
                      SOURCES test_${_test}.cc
                      LIBS fdb5
                      ENVIRONMENT "${_test_environment}" )

endforeach()

=== tests/regressions/FDB-238/CMakeLists.txt ===
ecbuild_configure_file( FDB-238.sh.in FDB-238.sh @ONLY )

ecbuild_add_test(
    TYPE     SCRIPT
    COMMAND  FDB-238.sh )

=== debian/changelog ===
fdb (5.15.12-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 30 Mar 2025 10:44:10 +0100

=== debian/control ===
--- 
+++ 
@@ -6,16 +6,16 @@
 Build-Depends: debhelper-compat (=13),
  architecture-is-64-bit,
  ecbuild (>= 3.3.0-3),
- libeckit-dev (>= 1.25.0-1~),
+ libeckit-dev (>= 1.28.5-2),
  libeccodes-dev,
  libopenjp2-7-dev,
  libmetkit-dev (>= 1.12.0-1~),
  libmetkit-utils ,
  libodc-dev,
  libpmem-dev [amd64 arm64 ppc64el riscv64],
- librados-dev [!sparc64 !ppc64 !alpha !loong64],
+ librados-dev,
  libeccodes-tools
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/ecmwf/fdb
 Vcs-Browser: https://salsa.debian.org/science-team/fdb.git
 Vcs-Git: https://salsa.debian.org/science-team/fdb.git -b debian/latest

=== debian/rules ===
--- 
+++ 
@@ -14,8 +14,9 @@
 ARCH_PMEM:= amd64 arm64 ppc64el
 DO_PMEM:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_PMEM)),ON,OFF)
 
-ARCH_NORADOS:= alpha loong64 ppc64 sparc64
-DO_RADOS:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_NORADOS)),OFF,ON)
+ARCH_NORADOS:= alpha ppc64 sparc64
+# DO_RADOS:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_NORADOS)),OFF,ON)
+DO_RADOS:= Off
 
 # The magic debhelper  rule
 %:
@@ -25,8 +26,8 @@
 # Disable for now
 BUILD_FLAGS:=  -DENABLE_RPATHS=OFF \
 		-DENABLE_RELATIVE_RPATHS=OFF \
-		-DENABLE_PMEMFDB=OFF \
-		-DENABLE_RADOSFDB=OFF \
+		-DENABLE_PMEMFDB=$(DO_PMEM) \
+		-DENABLE_RADOSFDB=$(DO_RADOS) \
 		-DENABLE_LUSTRE=OFF 
 
 override_dh_auto_configure:

## fdb 5.15.15

=== docs/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-find_package(Doxygen 1.13 REQUIRED)
+find_package(Doxygen 1.9 REQUIRED)
 find_package(Sphinx REQUIRED)
 
 file(GLOB_RECURSE FDB_PUBLIC_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/../src/fdb5/api/*.h)

=== debian/changelog ===
fdb (5.15.15-1) experimental; urgency=medium

  * New upstream release
  * B-D on metkit > 1.31.1. Closes: #1104354

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 02 May 2025 09:36:07 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  libeckit-dev (>= 1.28.5-2),
  libeccodes-dev,
  libopenjp2-7-dev,
- libmetkit-dev (>= 1.12.0-1~),
+ libmetkit-dev (>= 1.13.1-1~),
  libmetkit-utils ,
  libodc-dev,
  libpmem-dev [amd64 arm64 ppc64el riscv64],

## fdb 5.17.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 
 set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support
 
-ecbuild_find_package( NAME eckit  VERSION 1.28.3 REQUIRED )
+ecbuild_find_package( NAME eckit  VERSION 1.28.6 REQUIRED )
 
 ### GRIB support

=== tests/fdb/CMakeLists.txt ===
--- 
+++ 
@@ -68,3 +68,7 @@
 add_subdirectory( tools )
 add_subdirectory( type )
 add_subdirectory( daos )
+
+if (HAVE_FDB_REMOTE)
+    add_subdirectory( remote )
+endif()

=== tests/regressions/CMakeLists.txt ===
--- 
+++ 
@@ -29,6 +29,7 @@
     if (HAVE_FDB_REMOTE)
         add_subdirectory(FDB-258)
         add_subdirectory(FDB-419)
+        add_subdirectory(FDB-491)
     endif()
 
 endif()

=== tests/fdb/remote/CMakeLists.txt ===
# Client side of test
ecbuild_add_executable(
    TARGET    fdb_test_remote_api_bin
    SOURCES   test_remote_api.cc
    INCLUDES  ${ECKIT_INCLUDE_DIRS}
    LIBS      fdb5
    NOINSTALL
)

if (HAVE_FDB_BUILD_TOOLS AND HAVE_GRIB)
    ecbuild_configure_file( test_server.sh.in fdb_test_server.sh @ONLY )
    set(FDB_TEST_SERVER_SCRIPT "${CMAKE_CURRENT_BINARY_DIR}/fdb_test_server.sh" CACHE INTERNAL "")

    # Basic API test using "standard" configuration
    ecbuild_configure_file( catalogue.yaml.in catalogue.yaml @ONLY )
    ecbuild_configure_file( store.yaml.in store.yaml @ONLY )
    ecbuild_configure_file( client.yaml.in client.yaml @ONLY )

    ecbuild_add_test(
        TARGET         fdb_test_remote_api
        TYPE           SCRIPT
        COMMAND        ${FDB_TEST_SERVER_SCRIPT}
        ARGS           ${CMAKE_CURRENT_BINARY_DIR} client.yaml catalogue.yaml store.yaml
        TEST_DEPENDS   fdb_test_remote_api_bin
        RESOURCE_LOCK  fdb_remote_tests # Prevent concurrent runs of remote tests
        LABELS         remotefdb
    )
    set_tests_properties(fdb_test_remote_api PROPERTIES TIMEOUT 300)
endif()

=== tests/regressions/FDB-419/CMakeLists.txt ===

set(SCHEMA_PATH ${CMAKE_CURRENT_SOURCE_DIR}/schema)
set(SPACE_ROOT_PATH ${CMAKE_CURRENT_BINARY_DIR})
ecbuild_configure_file(
    fdb_client_config.yaml.in
    fdb_client_config.yaml
    @ONLY
)
ecbuild_configure_file(
    fdb_server_config.yaml.in
    fdb_server_config.yaml
    @ONLY
)
ecbuild_add_test( 
    TARGET FDB-419
    SOURCES fdb_419_regression_test.cc
    LIBS fdb5 eckit metkit
    ENVIRONMENT FDB_SERVER_EXECUTABLE=$<TARGET_FILE:fdb-server>
    RESOURCE_LOCK  fdb_remote_tests  # Prevent concurrent runs of remote tests
    LABELS remotefdb
)

=== tests/regressions/FDB-491/CMakeLists.txt ===
# Run remote API tests, but with the singleConnection option set in the server configs

if (NOT DEFINED FDB_TEST_SERVER_SCRIPT)
    message(FATAL_ERROR "FDB_TEST_SERVER_SCRIPT is not defined. Please ensure the test server script is configured correctly.")
endif()

ecbuild_configure_file( catalogue.yaml.in catalogue.yaml @ONLY )
ecbuild_configure_file( store.yaml.in store.yaml @ONLY )
ecbuild_configure_file( client.yaml.in client.yaml @ONLY )

ecbuild_add_test(
    TARGET         FDB-491-remote-single-connection
    TYPE           SCRIPT
    COMMAND        ${FDB_TEST_SERVER_SCRIPT}
    ARGS           ${CMAKE_CURRENT_BINARY_DIR} client.yaml catalogue.yaml store.yaml
    TEST_DEPENDS   fdb_test_remote_api_bin
    RESOURCE_LOCK  fdb_remote_tests  # Prevent concurrent runs of remote tests
    LABELS         remotefdb
)

set_tests_properties(FDB-491-remote-single-connection PROPERTIES TIMEOUT 300)

=== debian/changelog ===
fdb (5.17.0-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 27 Jun 2025 11:38:18 +0100

fdb (5.16.2-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 26 May 2025 05:37:43 +0100

fdb (5.16.1-1) experimental; urgency=medium

  * New upstream release
  * Build-dep on libmetkit-dev >= 1.13.1-2

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 22 May 2025 08:30:33 +0100

## fdb 5.17.3

=== debian/changelog ===
fdb (5.17.3-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 15 Jul 2025 10:07:04 +0100

fdb (5.17.2-1) experimental; urgency=medium

  * New upstream release
  * dep-on-libc.patch: plugins must link against libc for versioning
  * Add libdaos and tests libs

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 09 Jul 2025 09:37:14 +0100

fdb (5.17.1-1) experimental; urgency=medium

  * New upstream release
  * Add daos: headers and libs
  * Add lintian override on libc warning on dummy lib
  * Replace old FSF address in d/copyright

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 05 Jul 2025 10:27:52 +0100

=== debian/control ===
--- 
+++ 
@@ -6,10 +6,10 @@
 Build-Depends: debhelper-compat (=13),
  architecture-is-64-bit,
  ecbuild (>= 3.3.0-3),
- libeckit-dev (>= 1.28.5-2),
+ libeckit-dev (>= 1.29.3-1~),
  libeccodes-dev,
  libopenjp2-7-dev,
- libmetkit-dev (>= 1.13.1-1~),
+ libmetkit-dev (>= 1.13.1-2),
  libmetkit-utils ,
  libodc-dev,
  libpmem-dev [amd64 arm64 ppc64el riscv64],
